<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "https://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
<meta http-equiv="X-UA-Compatible" content="IE=9"/>
<meta name="generator" content="Doxygen 1.8.16"/>
<meta name="viewport" content="width=device-width, initial-scale=1"/>
<title>Zonzay: test::tester Class Reference</title>
<link href="tabs.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="jquery.js"></script>
<script type="text/javascript" src="dynsections.js"></script>
<link href="search/search.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="search/searchdata.js"></script>
<script type="text/javascript" src="search/search.js"></script>
<link href="doxygen.css" rel="stylesheet" type="text/css" />
</head>
<body>
<div id="top"><!-- do not remove this div, it is closed by doxygen! -->
<div id="titlearea">
<table cellspacing="0" cellpadding="0">
 <tbody>
 <tr style="height: 56px;">
  <td id="projectlogo"><img alt="Logo" src="zonzay.png"/></td>
  <td id="projectalign" style="padding-left: 0.5em;">
   <div id="projectname">Zonzay
   &#160;<span id="projectnumber">1</span>
   </div>
   <div id="projectbrief">Laugh game challenge</div>
  </td>
 </tr>
 </tbody>
</table>
</div>
<!-- end header part -->
<!-- Generated by Doxygen 1.8.16 -->
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:cf05388f2679ee054f2beb29a391d25f4e673ac3&amp;dn=gpl-2.0.txt GPL-v2 */
var searchBox = new SearchBox("searchBox", "search",false,'Search');
/* @license-end */
</script>
<script type="text/javascript" src="menudata.js"></script>
<script type="text/javascript" src="menu.js"></script>
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:cf05388f2679ee054f2beb29a391d25f4e673ac3&amp;dn=gpl-2.0.txt GPL-v2 */
$(function() {
  initMenu('',true,false,'search.php','Search');
  $(document).ready(function() { init_search(); });
});
/* @license-end */</script>
<div id="main-nav"></div>
<!-- window showing the filter options -->
<div id="MSearchSelectWindow"
     onmouseover="return searchBox.OnSearchSelectShow()"
     onmouseout="return searchBox.OnSearchSelectHide()"
     onkeydown="return searchBox.OnSearchSelectKey(event)">
</div>

<!-- iframe showing the search results (closed by default) -->
<div id="MSearchResultsWindow">
<iframe src="javascript:void(0)" frameborder="0" 
        name="MSearchResults" id="MSearchResults">
</iframe>
</div>

<div id="nav-path" class="navpath">
  <ul>
<li class="navelem"><b>test</b></li><li class="navelem"><a class="el" href="classtest_1_1tester.html">tester</a></li>  </ul>
</div>
</div><!-- top -->
<div class="header">
  <div class="summary">
<a href="#pub-methods">Public Member Functions</a> &#124;
<a href="#pri-attribs">Private Attributes</a> &#124;
<a href="classtest_1_1tester-members.html">List of all members</a>  </div>
  <div class="headertitle">
<div class="title">test::tester Class Reference</div>  </div>
</div><!--header-->
<div class="contents">

<p><code>#include &lt;<a class="el" href="tester_8h_source.html">tester.h</a>&gt;</code></p>
<table class="memberdecls">
<tr class="heading"><td colspan="2"><h2 class="groupheader"><a name="pub-methods"></a>
Public Member Functions</h2></td></tr>
<tr class="memitem:a462b3e60d6c563a250ba8b9aa45639cc"><td class="memItemLeft" align="right" valign="top">&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classtest_1_1tester.html#a462b3e60d6c563a250ba8b9aa45639cc">tester</a> (const std::string &amp;<a class="el" href="classtest_1_1tester.html#a230a51eb9c8f14ffe30778f1197a107d">switch_name</a>, const std::string &amp;description_, unsigned long num_of_args_=0)</td></tr>
<tr class="separator:a462b3e60d6c563a250ba8b9aa45639cc"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a56d0a28d81957113b70ac520a744e6f5"><td class="memItemLeft" align="right" valign="top">virtual&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classtest_1_1tester.html#a56d0a28d81957113b70ac520a744e6f5">~tester</a> ()</td></tr>
<tr class="separator:a56d0a28d81957113b70ac520a744e6f5"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:aca3d30649b9d5b839eddeb2ec95bc38c"><td class="memItemLeft" align="right" valign="top"><a id="aca3d30649b9d5b839eddeb2ec95bc38c"></a>
const std::string &amp;&#160;</td><td class="memItemRight" valign="bottom"><b>cmd_line_switch</b> () const</td></tr>
<tr class="separator:aca3d30649b9d5b839eddeb2ec95bc38c"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a84b21618f32c604c1210fca2ec3f4f98"><td class="memItemLeft" align="right" valign="top">const std::string &amp;&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classtest_1_1tester.html#a84b21618f32c604c1210fca2ec3f4f98">description</a> () const</td></tr>
<tr class="separator:a84b21618f32c604c1210fca2ec3f4f98"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a33f2b1edb3b9d8703e2babfff6541e80"><td class="memItemLeft" align="right" valign="top">unsigned long&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classtest_1_1tester.html#a33f2b1edb3b9d8703e2babfff6541e80">num_of_args</a> () const</td></tr>
<tr class="separator:a33f2b1edb3b9d8703e2babfff6541e80"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:ae34ca676a619d7a510be20c73a181729"><td class="memItemLeft" align="right" valign="top">virtual void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classtest_1_1tester.html#ae34ca676a619d7a510be20c73a181729">perform_test</a> ()</td></tr>
<tr class="separator:ae34ca676a619d7a510be20c73a181729"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a73c549f0ba3da2982d47631d20b83ad9"><td class="memItemLeft" align="right" valign="top">virtual void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classtest_1_1tester.html#a73c549f0ba3da2982d47631d20b83ad9">perform_test</a> (const std::string &amp;arg)</td></tr>
<tr class="separator:a73c549f0ba3da2982d47631d20b83ad9"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a35852dc0b7eb330661ff9cec6de21650"><td class="memItemLeft" align="right" valign="top">virtual void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classtest_1_1tester.html#a35852dc0b7eb330661ff9cec6de21650">perform_test</a> (const std::string &amp;arg1, const std::string &amp;arg2)</td></tr>
<tr class="separator:a35852dc0b7eb330661ff9cec6de21650"><td class="memSeparator" colspan="2">&#160;</td></tr>
</table><table class="memberdecls">
<tr class="heading"><td colspan="2"><h2 class="groupheader"><a name="pri-attribs"></a>
Private Attributes</h2></td></tr>
<tr class="memitem:a230a51eb9c8f14ffe30778f1197a107d"><td class="memItemLeft" align="right" valign="top">const std::string&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classtest_1_1tester.html#a230a51eb9c8f14ffe30778f1197a107d">switch_name</a></td></tr>
<tr class="separator:a230a51eb9c8f14ffe30778f1197a107d"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:ad4c77b94923389dda5166280d37b1c5b"><td class="memItemLeft" align="right" valign="top"><a id="ad4c77b94923389dda5166280d37b1c5b"></a>
const std::string&#160;</td><td class="memItemRight" valign="bottom"><b>description_</b></td></tr>
<tr class="separator:ad4c77b94923389dda5166280d37b1c5b"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a1b56cc84ef45cd701f338b8a831c5e01"><td class="memItemLeft" align="right" valign="top"><a id="a1b56cc84ef45cd701f338b8a831c5e01"></a>
const unsigned long&#160;</td><td class="memItemRight" valign="bottom"><b>num_of_args_</b></td></tr>
<tr class="separator:a1b56cc84ef45cd701f338b8a831c5e01"><td class="memSeparator" colspan="2">&#160;</td></tr>
</table>
<a name="details" id="details"></a><h2 class="groupheader">Detailed Description</h2>
<div class="textblock"><pre class="fragment">ensures
    - reprints the spinner
</pre><p> ! </p>
</div><h2 class="groupheader">Constructor &amp; Destructor Documentation</h2>
<a id="a462b3e60d6c563a250ba8b9aa45639cc"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a462b3e60d6c563a250ba8b9aa45639cc">&#9670;&nbsp;</a></span>tester()</h2>

<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">test::tester::tester </td>
          <td>(</td>
          <td class="paramtype">const std::string &amp;&#160;</td>
          <td class="paramname"><em>switch_name</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">const std::string &amp;&#160;</td>
          <td class="paramname"><em>description_</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">unsigned long&#160;</td>
          <td class="paramname"><em>num_of_args_</em> = <code>0</code>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td>
        </tr>
      </table>
</div><div class="memdoc">
<pre class="fragment">WHAT THIS OBJECT REPRESENTS
    This object represents a generic regression test.
</pre><p> ! </p>

</div>
</div>
<a id="a56d0a28d81957113b70ac520a744e6f5"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a56d0a28d81957113b70ac520a744e6f5">&#9670;&nbsp;</a></span>~tester()</h2>

<div class="memitem">
<div class="memproto">
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">virtual test::tester::~tester </td>
          <td>(</td>
          <td class="paramname"></td><td>)</td>
          <td></td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">inline</span><span class="mlabel">virtual</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">
<pre class="fragment">requires
    - testers().is_in_domain(switch_name) == false
ensures
    - #cmd_line_switch() == switch_name
    - #description() == description_
    - #num_of_args() == num_of_args_
    - adds this tester to the testers() map.
</pre><p> ! </p>

</div>
</div>
<h2 class="groupheader">Member Function Documentation</h2>
<a id="a84b21618f32c604c1210fca2ec3f4f98"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a84b21618f32c604c1210fca2ec3f4f98">&#9670;&nbsp;</a></span>description()</h2>

<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">const std::string &amp; test::tester::description </td>
          <td>(</td>
          <td class="paramname"></td><td>)</td>
          <td> const</td>
        </tr>
      </table>
</div><div class="memdoc">
<pre class="fragment">ensures
    - returns the name of the command line switch for this tester.
</pre><p> ! </p>

</div>
</div>
<a id="a33f2b1edb3b9d8703e2babfff6541e80"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a33f2b1edb3b9d8703e2babfff6541e80">&#9670;&nbsp;</a></span>num_of_args()</h2>

<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">unsigned long test::tester::num_of_args </td>
          <td>(</td>
          <td class="paramname"></td><td>)</td>
          <td> const</td>
        </tr>
      </table>
</div><div class="memdoc">
<pre class="fragment">ensures
    - returns the description of what this tester tests.
</pre><p> ! </p>

</div>
</div>
<a id="ae34ca676a619d7a510be20c73a181729"></a>
<h2 class="memtitle"><span class="permalink"><a href="#ae34ca676a619d7a510be20c73a181729">&#9670;&nbsp;</a></span>perform_test() <span class="overload">[1/3]</span></h2>

<div class="memitem">
<div class="memproto">
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">void test::tester::perform_test </td>
          <td>(</td>
          <td class="paramname"></td><td>)</td>
          <td></td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">virtual</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">
<pre class="fragment">ensures
    - returns the number of arguments this test expects
</pre><p> ! </p>

</div>
</div>
<a id="a73c549f0ba3da2982d47631d20b83ad9"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a73c549f0ba3da2982d47631d20b83ad9">&#9670;&nbsp;</a></span>perform_test() <span class="overload">[2/3]</span></h2>

<div class="memitem">
<div class="memproto">
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">void test::tester::perform_test </td>
          <td>(</td>
          <td class="paramtype">const std::string &amp;&#160;</td>
          <td class="paramname"><em>arg</em></td><td>)</td>
          <td></td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">virtual</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">
<pre class="fragment">requires
    - is invoked when number_of_args() == 0
ensures
    - performs the test and throws an exception 
      derived from std::exception if the test fails.
</pre><p> ! </p>

</div>
</div>
<a id="a35852dc0b7eb330661ff9cec6de21650"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a35852dc0b7eb330661ff9cec6de21650">&#9670;&nbsp;</a></span>perform_test() <span class="overload">[3/3]</span></h2>

<div class="memitem">
<div class="memproto">
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">void test::tester::perform_test </td>
          <td>(</td>
          <td class="paramtype">const std::string &amp;&#160;</td>
          <td class="paramname"><em>arg1</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">const std::string &amp;&#160;</td>
          <td class="paramname"><em>arg2</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">virtual</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">
<pre class="fragment">requires
    - is invoked when number_of_args() == 1
ensures
    - performs the test and throws an exception 
      derived from std::exception if the test fails.
</pre><p> ! </p>

</div>
</div>
<h2 class="groupheader">Member Data Documentation</h2>
<a id="a230a51eb9c8f14ffe30778f1197a107d"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a230a51eb9c8f14ffe30778f1197a107d">&#9670;&nbsp;</a></span>switch_name</h2>

<div class="memitem">
<div class="memproto">
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">const std::string test::tester::switch_name</td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">private</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">
<pre class="fragment">requires
    - is invoked when number_of_args() == 2
ensures
    - performs the test and throws an exception 
      derived from std::exception if the test fails.
</pre><p> !</p>
<pre class="fragment">CONVENTION
    - switch_name == cmd_line_switch()
    - description_ == description()
    - num_of_args_ == num_of_args()
    - test::tester[switch_name] == this
</pre><p> ! </p>

</div>
</div>
<hr/>The documentation for this class was generated from the following files:<ul>
<li><a class="el" href="tester_8h_source.html">tester.h</a></li>
<li>tester.cpp</li>
</ul>
</div><!-- contents -->
<!-- start footer part -->
<hr class="footer"/><address class="footer"><small>
Generated by &#160;<a href="http://www.doxygen.org/index.html">
<img class="footer" src="doxygen.png" alt="doxygen"/>
</a> 1.8.16
</small></address>
</body>
</html>
